<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.platform.plugin.*,
				com.webassign.Conn,
                com.webassign.Props,
                com.webassign.SOAP"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">

<%
	boolean validCode = false;
	boolean emptyCode = true;
	boolean connected = true;

    String institutionCode = request.getParameter("institutionCode").toLowerCase();
	String institutionName = null;
	String institutionTimezone = null;
	String institutionCalendar = null;

	if (com.webassign.Conn.webassignIsUp()) {
		File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
		File configFile = new File(configDir,com.webassign.Props.propFileName());
		com.webassign.Props waprops = new com.webassign.Props(configFile);

		if (institutionCode.length() > 0) {
			emptyCode = false;
			com.webassign.SOAP waSOAP = new com.webassign.SOAP("verifycode");
			waSOAP.addElem("institution",institutionCode);
			waSOAP.sendCall();

			if (waSOAP.getResultByKey("result").equals("valid")) {
				validCode = true;
				institutionName = waSOAP.getResultByKey("name");
				institutionTimezone = waSOAP.getResultByKey("timezone");
				institutionCalendar = waSOAP.getResultByKey("calendar");
				waprops.setProp("institution.code",institutionCode);
				waprops.setProp("institution.key",waSOAP.getResultByKey("institutionKey"));
				waprops.setProp("institution.billing",waSOAP.getResultByKey("billing"));
				waprops.saveProps();
			}
		}
		else {
			waprops.setProp("institution.code","");
			waprops.saveProps();
		}
	}
	else {
		connected = false;
	}
%>

<bbUI:docTemplate title="WebAssignInstitution">

<bbUI:breadcrumbBar handle="admin_plugin_manage">
    <bbUI:breadcrumb> WebAssign Institution Code</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<% if (connected) { %>
<%   if (validCode) { %>
<bbUI:receipt type="SUCCESS">
Your WebAssign Institution Code has been saved successfully.<br>
<p>Your WebAssign Institution Code has the following attributes.</p>

Institution Name: <%=institutionName%><br>
Timezone: <%=institutionTimezone%><br>
Calendar: <%=institutionCalendar%><br>

<p>If your institution is not <%=institutionName%>, please repeat step 1.
If you entered the correct code, but the attributes are incorrect, please contact
<a href="mailto:support@webassign.net">WebAssign</a>.</p>
</bbUI:receipt>
<%   } else if (emptyCode) { %>
<bbUI:receipt type="SUCCESS">
Your WebAssign Institution Code has been reset.
</bbUI:receipt>
<%   } else { %>
<bbUI:receipt type="FAIL">The Institution Code entered was not valid. Please try again.</bbUI:receipt>
<%   } %>
<% } else { %>
<bbUI:receipt type="FAIL">A connection could not be established with WebAssign. Please try again later.</bbUI:receipt>
<% } %>

</bbUI:docTemplate>

</bbData:context>
