<%@page import="java.io.*,
                java.util.*,
                blackboard.base.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.course.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
				blackboard.platform.plugin.*,
                blackboard.platform.session.*,
				com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	// get course properties
	boolean linkedCourse = false;
	Course bbcourse = ctx.getCourse();
	BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
	FileSystemService fileSysService = (FileSystemService)
		BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
	File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
	File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

	boolean connected = true;
	String wacourseID = null;
	if (com.webassign.Conn.webassignIsUp()) {
		com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
		wacourseID = wacourseprops.getProp("course.id");
		if (wacourseID.length() > 0) linkedCourse = true;
	}
	else {
		connected = false;
	}

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String unlinkHref = "javascript:unlinkConfirm('" + ctx.getCourseId().toExternalString() + "')";

	ArrayList watermOptions = new ArrayList();
	ArrayList wapaymentOptions = new ArrayList();
%>

<bbUI:docTemplate title="Create WebAssign Course">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Create WebAssign Course</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:titleBar iconUrl="/images/ci/icons/bookopen_u.gif">Create WebAssign Course</bbUI:titleBar>

<% if (connected) { %>

<%
	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");
%>

<%   if (linkedCourse) { %>

<%
	String wacoursename = null;

	com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("getCourseInfo");
	wacourseSOAP.addElem("course",wacourseID);
	wacourseSOAP.addElem("institution",institutionCode);
	wacourseSOAP.sendCall(institutionKey);

	if ((!wacourseSOAP.droppedCall())
	&& (wacourseSOAP.getResultByKey("result").equals("valid"))) {
		wacoursename = wacourseSOAP.getResultByKey("name");
	}
%>

<%     if (wacoursename != null) {%>
<p>Your Blackboard course is already linked to your WebAssign course <%=wacoursename%>.
<%     } else { %>
<p>Your Blackboard course is already linked to your WebAssign course.
<%     } %>

<script type="text/javascript" language="javascript"><!--
function unlinkConfirm (course_id) {
	if (confirm('Are you sure you want to unlink this course?')) {
		document.waunlinkForm.course_id.value = course_id;
		document.waunlinkForm.submit(this);
	}
}
// --></script>
<form method="post" name="waunlinkForm" action="unlink.jsp">
<input type="hidden" name="course_id" value="">
If you would like to remove this link, click <a href="<%=unlinkHref%>">here</a>.</p>
</form>
<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } else { // unlinked course %>

<form method="post" name="wacourseForm" action="docreate.jsp">
<input type="hidden" name="course_id" value="<%=ctx.getCourseId().toExternalString()%>">

<%
	String institutionBilling = waprops.getProp("institution.billing");

	com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("getCourseOptions");
	wacourseSOAP.addElem("institution",institutionCode);
	wacourseSOAP.sendCall(institutionKey);

	int snum = 1;
	String stepnum = Integer.toString(snum);

	boolean fault = false;
	boolean cerror = false;
	if (wacourseSOAP.droppedCall()) {
		fault = true;
	}
	else if (wacourseSOAP.getResultByKey("result").equals("options")) {
		String termcount = wacourseSOAP.getResultByKey("termcount");
		int tcount = Integer.parseInt(termcount);
		for (int i = 0; i < tcount; i++) {
			Hashtable htable = new Hashtable();
			htable.put("termID",wacourseSOAP.getResultByKey("term" + i + "ID"));
			htable.put("termname",wacourseSOAP.getResultByKey("term" + i + "name"));
			watermOptions.add(i,htable);
		}
		String paymentcount = wacourseSOAP.getResultByKey("paymentcount");
		int pcount = Integer.parseInt(paymentcount);
		for (int i = 0; i < pcount; i++) {
			Hashtable htable = new Hashtable();
			htable.put("paymentID",wacourseSOAP.getResultByKey("payment" + i + "ID"));
			htable.put("paymentname",wacourseSOAP.getResultByKey("payment" + i + "name"));
			wapaymentOptions.add(i,htable);
		}
	}
	else {
		cerror = true;
	}

	// find instructor(s) of this course
	boolean haveInstructor = false;
	boolean haveInstructorList = false;
	List bbInstructorsWithAccount = new ArrayList();

	CourseMembershipDbLoader cmLoader = (CourseMembershipDbLoader) bbPm.getLoader( CourseMembershipDbLoader.TYPE );
	BbList instructorList = cmLoader.loadByCourseIdAndRole(bbcourse.getId(),CourseMembership.Role.INSTRUCTOR);
	UserDbLoader uLoader = (UserDbLoader) bbPm.getLoader( UserDbLoader.TYPE );
	if (instructorList.size() == 1) {
		CourseMembership cm = (CourseMembership) instructorList.get(0);
		User u = uLoader.loadById(cm.getUserId());
		com.webassign.SOAP wauserSOAP = new com.webassign.SOAP("getUserID");
		wauserSOAP.addElem("username",u.getUserName());
		wauserSOAP.addElem("institution",institutionCode);
		wauserSOAP.sendCall(institutionKey);
		if (wauserSOAP.droppedCall()) {
			fault = true;
		}
		else if (wauserSOAP.getResultByKey("result").equals("exists")) {
			haveInstructor = true;
		}
	}
	else {
		User bbuser = ctx.getUser();
		boolean bbuserListed = false;
		for (int i = 0; i < instructorList.size(); i++) {
			CourseMembership cm = (CourseMembership) instructorList.get(i);
			User u = uLoader.loadById(cm.getUserId());
			com.webassign.SOAP wauserSOAP = new com.webassign.SOAP("getUserID");
			wauserSOAP.addElem("username",u.getUserName());
			wauserSOAP.addElem("institution",institutionCode);
			wauserSOAP.sendCall(institutionKey);
			if (wauserSOAP.droppedCall()) {
				fault = true;
			}
			else if (wauserSOAP.getResultByKey("result").equals("exists")) {
				Hashtable htable = new Hashtable();
				htable.put("userName",u.getUserName());
				htable.put("userFullname",u.getFamilyName() + ", " + u.getGivenName() + " " + u.getMiddleName());
				if (u.getUserName().equals(bbuser.getUserName())) {
					htable.put("selected","selected");
					bbuserListed = true;
				}
				else {
					htable.put("selected","");
				}
				int bbInstructorsIndex = bbInstructorsWithAccount.size();
				bbInstructorsWithAccount.add(bbInstructorsIndex,htable);
				haveInstructorList = true;
			}
		}
		if (bbuserListed && (bbInstructorsWithAccount.size() == 1)) {
			haveInstructor = true;
			haveInstructorList = false;
		}
	}
%>

<%     if (fault || cerror) { %>

<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>

<%     } else if (haveInstructor || haveInstructorList) { %>
<bbUI:step title="Course Information" number="<%=stepnum%>">
	<bbUI:instructions>
	To create your WebAssign course, please enter the information below.
	</bbUI:instructions>

	<bbUI:dataElement label="Course Name">
	<%=bbcourse.getTitle()%>
	</bbUI:dataElement>

	<bbUI:dataElement label="Description">
	<%=bbcourse.getDescription()%>
	</bbUI:dataElement>

	<bbUI:dataElement label="Term" required="true">
	<select name="waterm">
<%
	snum++;
	stepnum = Integer.toString(snum);
	ListIterator watermIterator = watermOptions.listIterator();
	while (watermIterator.hasNext()) {
		Hashtable htable = (Hashtable)watermIterator.next();
		String termID = htable.get("termID").toString();
		String termname = htable.get("termname").toString();
%>
	<option value="<%=termID%>"><%=termname%></option>
<%  } %>
	</select>

	<input type="<%=wacourseSOAP.getResultByKey("yeartype")%>" name="wayear" value="<%=wacourseSOAP.getResultByKey("year")%>" size="5">
	</bbUI:dataElement>
</bbUI:step>

<bbUI:step title="Course Duration" number="<%=stepnum%>">

<%
	snum++;
	Date starts = null;
	if (bbcourse.getStartDate() != null) {
		starts = bbcourse.getStartDate().getTime();
	}
	Date ends = null;
	if (bbcourse.getEndDate() != null) {
		ends = bbcourse.getEndDate().getTime();
	}
%>

	<bbUI:dataElement label="Dates" required="true">
		<bbUI:dateAvailability formName="wacourseForm" startDate="<%=starts%>" endDate="<%=ends%>" startDateField="waStartDate" endDateField="waEndDate" startCaption="Starts" endCaption="Ends" />
	</bbUI:dataElement>
</bbUI:step>

<%       if (haveInstructorList) { %>
<%
	stepnum = Integer.toString(snum);
%>
<bbUI:step title="Course Instructor" number="<%=stepnum%>">
	<bbUI:dataElement label="User" required="true">
	<select name="instructor">
<%
	snum++;
	ListIterator bbInstructorIterator = bbInstructorsWithAccount.listIterator();
	while (bbInstructorIterator.hasNext()) {
		Hashtable htable = (Hashtable)bbInstructorIterator.next();
		String userName = htable.get("userName").toString();
		String userFullname = htable.get("userFullname").toString();
		String selected = "";
		if (htable.get("selected").toString().equals("selected")) selected = " selected";
%>
    <option value="<%=userName%>"<%=selected%>><%=userFullname%></option>
<%  } %>
	</select>
	</bbUI:dataElement>
</bbUI:step>
<%       } %>

<%       if ((institutionBilling == null) || (institutionBilling.length() == 0)) { %>
<%
	stepnum = Integer.toString(snum);
%>
<bbUI:step title="Student Fee" number="<%=stepnum%>">

	<bbUI:dataElement label="Payment Method" required="true">
<%
	snum++;
	ListIterator wapaymentIterator = wapaymentOptions.listIterator();
	while (wapaymentIterator.hasNext()) {
		Hashtable htable = (Hashtable)wapaymentIterator.next();
		String paymentID = htable.get("paymentID").toString();
		String paymentname = htable.get("paymentname").toString();
		String checked = "";
		if (paymentname.equals("Student Access Codes")) checked = " checked";
%>
	<input type="radio" name="wapayment" value="<%=paymentID%>"<%=checked%>><%=paymentname%><br>
<%  } %>
	</bbUI:dataElement>

	<bbUI:dataElement label="Payment Description">
	<textarea name="wapaymentdesc" rows="4" cols="50" wrap="soft"></textarea>
	</bbUI:dataElement>
</bbUI:step>
<%       } %>

<%
	stepnum = Integer.toString(snum);
%>
<bbUI:stepSubmit title="Submit" number="<%=stepnum%>" />

</form>
<%     } else { %>
<p>The instructor of this course does not appear to have a WebAssign account.</p>
<p>Please contact <a href="mailto:support@webassign.net">support@webassign.net</a> or visit
<a href="http://www.webassign.net/">http://www.webassign.net/</a> to find information
on how to obtain a WebAssign account.</p>
<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>
<%     } %>
<%   } %>
<% } else { %>
<p>WebAssign is currently unavailable or inaccessible. Please try again later.</p>
<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
