<%@page import="java.io.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );
	Course bbcourse = ctx.getCourse();

	boolean connected = true;
	boolean fault = false;
	boolean cerror = false;
	boolean courseCreated = false;

	if (com.webassign.Conn.webassignIsUp()) {
		File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
		File configFile = new File(configDir,com.webassign.Props.propFileName());
		com.webassign.Props waprops = new com.webassign.Props(configFile);
		String institutionCode = waprops.getProp("institution.code");
		String institutionKey = waprops.getProp("institution.key");

		User bbuser = ctx.getUser();

		com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("createCourse");
		wacourseSOAP.addElem("username",bbuser.getUserName());
		wacourseSOAP.addElem("institution",institutionCode);
		wacourseSOAP.addElem("name",bbcourse.getTitle());
		wacourseSOAP.addElem("description",bbcourse.getDescription());
		wacourseSOAP.addElem("term",request.getParameter("waterm"));
		wacourseSOAP.addElem("year",request.getParameter("wayear"));
		wacourseSOAP.addElem("starts",request.getParameter("waStartDate"));
		wacourseSOAP.addElem("ends",request.getParameter("waEndDate"));
		if (request.getParameter("instructor") == null) {
			wacourseSOAP.addElem("instructor",bbuser.getUserName());
		}
		else {
			wacourseSOAP.addElem("instructor",request.getParameter("instructor"));
		}
		if (request.getParameter("wapayment") == null) {
			wacourseSOAP.addElem("payment","");
			wacourseSOAP.addElem("paymentdesc","");
		}
		else {
			wacourseSOAP.addElem("payment",request.getParameter("wapayment"));
			if (request.getParameter("wapaymentdesc") == null) {
				wacourseSOAP.addElem("paymentdesc","");
			}
			else {
				wacourseSOAP.addElem("paymentdesc",request.getParameter("wapaymentdesc"));
			}
		}
		wacourseSOAP.sendCall(institutionKey);

		if (wacourseSOAP.droppedCall()) {
			fault = true;
		}
		else if (wacourseSOAP.getResultByKey("result").equals("success")) {
			BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
			FileSystemService fileSysService = (FileSystemService)
				BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
			File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
			File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

			String wacourseID = wacourseSOAP.getResultByKey("courseID");
			if ((wacourseID != null) && (wacourseID.length() > 0)) {
				com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
				wacourseprops.setProp("course.id",wacourseID);
				wacourseprops.saveProps();
				courseCreated = true;
			}
		}
		else {
			cerror = true;
		}
	}
	else {
		connected = false;
	}

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="Create WebAssign Course">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Create WebAssign Course</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<% if (connected) { %>
<%   if (fault || cerror) { %>
<bbUI:receipt type="FAIL" recallUrl="<%=mainHref%>">
There was an error processing this reqest. Please try again later.
</bbUI:receipt>
<%   } else if (courseCreated) { %>
<bbUI:receipt type="SUCCESS" recallUrl="<%=mainHref%>">
You have successfully created a WebAssign course and linked it to your Blackboard course.
</bbUI:receipt>
<%   } else { %>
<bbUI:receipt type="FAIL" recallUrl="<%=mainHref%>">
There was a problem creating or linking your course.
</bbUI:receipt>
<%   } %>
<% } else { %>
<p>WebAssign is currently unavailable or inaccessible. Please try again later.</p>
<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
