<%@page import="java.io.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	String wacourseID = request.getParameter("wacourse_id");
	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	boolean linkedCourse = false;
	boolean fault = false;
	boolean cerror = false;

	if (com.webassign.Conn.webassignIsUp()) {
		com.webassign.SOAP waSOAP = new com.webassign.SOAP("linkCourse");
		waSOAP.addElem("institution",institutionCode);
		waSOAP.addElem("course",wacourseID);
		waSOAP.sendCall(institutionKey);

		if (waSOAP.droppedCall()) {
			fault = true;
		}
		else if (waSOAP.getResultByKey("result").equals("success")) {
			Course bbcourse = ctx.getCourse();
			BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
			FileSystemService fileSysService = (FileSystemService)
				BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
			File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
			File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

			com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
			wacourseprops.setProp("course.id",wacourseID);
			wacourseprops.saveProps();

			linkedCourse = true;
		}
		else {
			cerror = true;
		}
	}

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="Link Course">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Link Course</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<% if (fault || cerror) { %>
<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>
<% } else if (linkedCourse) { %>
<bbUI:receipt type="SUCCESS" recallUrl="<%=mainHref%>">
You have successfully linked your Blackboard course to your WebAssign course.
</bbUI:receipt>
<% } else { %>
<bbUI:receipt type="FAIL" recallUrl="<%=mainHref%>">
Your Blackboard course could not be linked to your WebAssign course.
</bbUI:receipt>
<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
