<%@page import="java.io.*,
                java.util.*,
                blackboard.base.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.course.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	boolean linkedCourse = false;
	Course bbcourse = ctx.getCourse();
	BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
	FileSystemService fileSysService = (FileSystemService)
		BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
	File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
	File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

	com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
	String wacourseID = wacourseprops.getProp("course.id");
	if (wacourseID.length() > 0) linkedCourse = true;

	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	boolean fault = false;
	boolean cerror = false;

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="Link Course">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Link Course</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:titleBar iconUrl="/images/ci/icons/bookopen_u.gif">Link Course</bbUI:titleBar>

<% if (linkedCourse) { %>

<%
	String wacoursename = null;

	if (com.webassign.Conn.webassignIsUp()) {
		com.webassign.SOAP waSOAP = new com.webassign.SOAP("getCourseInfo");
		waSOAP.addElem("course",wacourseID);
		waSOAP.addElem("institution",institutionCode);
		waSOAP.sendCall(institutionKey);

		if (waSOAP.droppedCall()) {
			fault = true;
		}
		else if (waSOAP.getResultByKey("result").equals("valid")) {
			wacoursename = waSOAP.getResultByKey("name");
		}
	}

	String moreOptionsHref = "more.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String unlinkHref = "javascript:unlinkConfirm('" + ctx.getCourseId().toExternalString() + "')";
%>

<%   if (fault) { %>
<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>
<%   } else { %>
<%     if (wacoursename != null) { %>
<p>Your Blackboard course is already linked to your WebAssign course <%=wacoursename%>.
<%     } else { %>
<p>Your Blackboard course is already linked to your WebAssign course.
<%     } %>

<script type="text/javascript" language="javascript"><!--
function unlinkConfirm (course_id) {
	if (confirm('Are you sure you want to unlink this course?')) {
		document.waunlinkForm.course_id.value = course_id;
		document.waunlinkForm.submit(this);
	}
}
// --></script>
<form method="post" name="waunlinkForm" action="unlink.jsp">
<input type="hidden" name="course_id" value="">
If you would like to remove this link, click <a href="<%=unlinkHref%>">here</a>.</p>

<p><a href="<%=moreOptionsHref%>">Go to WebAssign</a> for more course options.</p>

</form>
<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } %>
<% } else { // unlinked course %>

<%
	boolean haveCourses = false;
	boolean haveMultipleInstructors = false;
	List wacourseList = new ArrayList();
	List waInstructorLists = new ArrayList();
	List waInstructorNames = new ArrayList();
	String wauserID = null;
	List bbInstructorsWithAccount = new ArrayList();

	if (com.webassign.Conn.webassignIsUp()) {
		// find instructor(s) of this course

		CourseMembershipDbLoader cmLoader = (CourseMembershipDbLoader) bbPm.getLoader( CourseMembershipDbLoader.TYPE );
		BbList instructorList = cmLoader.loadByCourseIdAndRole(bbcourse.getId(),CourseMembership.Role.INSTRUCTOR);
		UserDbLoader uLoader = (UserDbLoader) bbPm.getLoader( UserDbLoader.TYPE );
		User bbuser = ctx.getUser();
		boolean bbuserListed = false;
		for (int i = 0; i < instructorList.size(); i++) {
			CourseMembership cm = (CourseMembership) instructorList.get(i);
			User u = uLoader.loadById(cm.getUserId());
			com.webassign.SOAP wauserSOAP = new com.webassign.SOAP("getUserID");
			wauserSOAP.addElem("username",u.getUserName());
			wauserSOAP.addElem("institution",institutionCode);
			wauserSOAP.sendCall(institutionKey);
			if (wauserSOAP.droppedCall()) {
				fault = true;
			}
			else if (wauserSOAP.getResultByKey("result").equals("exists")) {
				Hashtable htable = new Hashtable();
				htable.put("wauserID",wauserSOAP.getResultByKey("userID"));
				htable.put("user",u);
				int bbInstructorsIndex = bbInstructorsWithAccount.size();
				bbInstructorsWithAccount.add(bbInstructorsIndex,htable);
				if (u.getUserName().equals(bbuser.getUserName())) wauserID = wauserSOAP.getResultByKey("userID");
			}
		}

		if (wauserID != null) {
			com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("coursesForInstructor");
			wacourseSOAP.addElem("userID",wauserID);
			wacourseSOAP.addElem("institution",institutionCode);
			wacourseSOAP.sendCall(institutionKey);

			if (wacourseSOAP.droppedCall()) {
				fault = true;
			}
			else if (wacourseSOAP.getResultByKey("result").equals("list")) {
				haveCourses = true;
				String scount = wacourseSOAP.getResultByKey("count");
				int count = Integer.parseInt(scount);
				for (int i = 0; i < count; i++) {
					Hashtable htable = new Hashtable();
					htable.put("courseID",wacourseSOAP.getResultByKey("course" + i + "ID"));
					htable.put("coursename",wacourseSOAP.getResultByKey("course" + i + "name"));
					wacourseList.add(i,htable);
				}
			}
			else if (!wacourseSOAP.getResultByKey("result").equals("none")) {
				cerror = true;
			}
		}
		else if (bbInstructorsWithAccount.size() > 0) {
			for (int i = 0; i < bbInstructorsWithAccount.size(); i++) {
				Hashtable htable = (Hashtable) bbInstructorsWithAccount.get(i);
				com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("coursesForInstructor");
				wacourseSOAP.addElem("userID",htable.get("wauserID").toString());
				wacourseSOAP.addElem("institution",institutionCode);
				wacourseSOAP.sendCall(institutionKey);

				if (wacourseSOAP.droppedCall()) {
					fault = true;
				}
				else if (wacourseSOAP.getResultByKey("result").equals("list")) {
					haveMultipleInstructors = true;
					List wausercourseList = new ArrayList();
					String scount = wacourseSOAP.getResultByKey("count");
					int count = Integer.parseInt(scount);
					for (int j = 0; j < count; j++) {
						Hashtable chtable = new Hashtable();
						chtable.put("courseID",wacourseSOAP.getResultByKey("course" + j + "ID"));
						chtable.put("coursename",wacourseSOAP.getResultByKey("course" + j + "name"));
						wausercourseList.add(j,chtable);
					}
					int waInstructorIndex = waInstructorLists.size();
					waInstructorLists.add(waInstructorIndex,wausercourseList);
					User u = (User) htable.get("user");
					String userFullname = u.getFamilyName() + ", " + u.getGivenName();
					waInstructorNames.add(waInstructorIndex,userFullname);
				}
				else if (!wacourseSOAP.getResultByKey("result").equals("none")) {
					cerror = true;
				}
			}
		}
	}
%>

<%   if (fault || cerror) { %>
<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>
<%   } else if (haveCourses) { %>

<p>You have access to the following WebAssign courses. Click the course you want to link to your Blackboard course.</p>
<p><ul>
<%
	ListIterator wacourseIterator = wacourseList.listIterator();
	while (wacourseIterator.hasNext()) {
		Hashtable htable = (Hashtable)wacourseIterator.next();
		String courseID = htable.get("courseID").toString();
		String coursename = htable.get("coursename").toString();
		String linkHref = "dolink.jsp?course_id=" + ctx.getCourseId().toExternalString() + "&wacourse_id=" + courseID;
%>
<li><a href="<%=linkHref%>"><%=coursename%></a></li>
<%  } %>
</ul></p>

<div align="right">
<bbUI:button type="FORM_ACTION" name="cancel" alt="Cancel" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } else if (haveMultipleInstructors) { %>

<p>You have access to the following WebAssign courses. Click the course you want to link to your Blackboard course.</p>
<p><ul>
<%
	for (int i = 0; i < waInstructorLists.size(); i++) {
%>
<li>
Instructor: <%=waInstructorNames.get(i)%>
<%
		List courseList = (ArrayList) waInstructorLists.get(i);
		ListIterator courseIterator = courseList.listIterator();
		while (courseIterator.hasNext()) {
			Hashtable htable = (Hashtable) courseIterator.next();
			String courseID = htable.get("courseID").toString();
			String coursename = htable.get("coursename").toString();
			String linkHref = "dolink.jsp?course_id=" + ctx.getCourseId().toExternalString() + "&wacourse_id=" + courseID;
%>
<ul>
<li><a href="<%=linkHref%>"><%=coursename%></a></li>
</ul>
<%      } %>
</li>
<%  } %>
</ul></p>

<div align="right">
<bbUI:button type="FORM_ACTION" name="cancel" alt="Cancel" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>
<%   } else if ((wauserID == null) && (bbInstructorsWithAccount.size() == 0)) { %>

<p>You do not appear to have a WebAssign account. Please contact <a href="mailto:support@webassign.net">support@webassign.net</a> for help.</p>
<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } else { %>

<p>No WebAssign courses were found.</p>
<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } %>
<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
