<%@page import="java.io.*,
                java.util.*,
                blackboard.base.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.course.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@taglib uri="/bbData" prefix="bbData"%>
<%@taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	// get institution properties
	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	boolean haveInstitution = false;
	if (institutionCode.length() > 0) haveInstitution = true;
	boolean haveInstitutionKey = false;
	if (institutionKey.length() > 0) haveInstitutionKey = true;

	// get course properties
	Course bbcourse = ctx.getCourse();
	BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
	FileSystemService fileSysService = (FileSystemService)
		BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
	File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
	File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

	boolean linkedCourse = false;
	com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
	String wacourseID = wacourseprops.getProp("course.id");
	if (wacourseID.length() > 0) linkedCourse = true;
	String wacoursename = null;

	boolean connected = true;
	Hashtable roles = new Hashtable();
	CourseMembership.Role[] allowedRoles = {
		CourseMembership.Role.INSTRUCTOR,
		CourseMembership.Role.TEACHING_ASSISTANT,
		CourseMembership.Role.GRADER,
		CourseMembership.Role.COURSE_BUILDER
	};
	String[] roleCheckboxes = {
		"instructor",
		"teaching_assistant",
		"grader",
		"course_builder"
	};
	String[] roleDisplay = {
		"Instructor",
		"Teacher's Assistant",
		"Grader",
		"Course Builder"
	};

	if (haveInstitution && haveInstitutionKey) {
		if (com.webassign.Conn.webassignIsUp()) {
			if (linkedCourse) {
				com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("getCourseInfo");
				wacourseSOAP.addElem("course",wacourseID);
				wacourseSOAP.addElem("institution",institutionCode);
				wacourseSOAP.sendCall(institutionKey);

				if ((!wacourseSOAP.droppedCall())
				&& (wacourseSOAP.getResultByKey("result").equals("valid"))) {
					wacoursename = wacourseSOAP.getResultByKey("name");
				}

				// find all roles
				CourseMembershipDbLoader cmLoader = (CourseMembershipDbLoader) bbPm.getLoader( CourseMembershipDbLoader.TYPE );
				UserDbLoader uLoader = (UserDbLoader) bbPm.getLoader( UserDbLoader.TYPE );
				BbList userList = uLoader.loadByCourseId(bbcourse.getId());
				ListIterator userIterator = userList.listIterator();
				while (userIterator.hasNext()) {
					User u = (User) userIterator.next();
					try {
						CourseMembership cm = cmLoader.loadByCourseAndUserId(bbcourse.getId(),u.getId());
						if (cm.getRole() != CourseMembership.Role.STUDENT) {
							if (!roles.containsKey(cm.getRole())) {
								roles.put(cm.getRole(),"true");
							}
						}
					} catch (Exception e) {
					}
				}
			}
		}
		else {
			connected = false;
		}
	}

	String createHref = "create.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String linkHref = "link.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String syncrosterHref = "javascript:document.syncroster.course_id.value='";
	syncrosterHref += ctx.getCourseId().toExternalString() + "'; document.syncroster.submit(this)";
%>

<bbUI:docTemplate title="WebAssign">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb> WebAssign</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:titleBar iconUrl="/images/ci/icons/bookopen_u.gif">WebAssign</bbUI:titleBar>

<p><a href="http://www.webassign.net/">WebAssign</a> is an online homework, quizzing, and
testing management system. As a teacher you can choose the questions for your assignment.
Your students will take it and WebAssign grades it. Your students will get immediate feedback
while your grade book is filled automatically. WebAssign takes Blackboard's assessment to the
next level. WebAssign's full-set of question types includes numerical, image map, multiple
answers, fill-in-the-blank, multiple choice, rank order, true/false, essay, symbolic or
algebraic, file upload, and poll all with full randomization of numbers, words, phrases, or
images in a multimode format. For science and mathematics, WebAssign has over 120,000 precoded,
randomized end-of-chapter questions from 100+ textbooks.</p>

<% if (connected) { %>
<%   if (!haveInstitution) { %>
<p>A WebAssign Institution Code has not been assigned to your Blackboard system. Please
ask your Blackboard system administrator to enter your WebAssign Institution code for your institution.</p>
<%   } else { %>
<%     if (linkedCourse) { %>
<%       if ((wacoursename != null) && (wacoursename.length() > 0)) { %>
<p>Your course is linked to the WebAssign course <%=wacoursename%>.</p>
<%       } else { %>
<p>Your course is linked to an existing WebAssign course.</p>
<%       } %>
<%     } else { %>
<p>Your Blackboard course is not yet linked to a WebAssign course. Choose one of
the options below to create a WebAssign course, if necessary, or to link to an existing
course in WebAssign. After linking your Blackboard course to a WebAssign course, you can
synchronize the class roster from Blackboard to WebAssign.</p>
<%     } %>

<form method="post" name="syncroster" action="syncroster.jsp">
<input type="hidden" name="course_id" value="">

<bbUI:caretList>
	<bbUI:caret title="Create WebAssign Course" href="<%=createHref%>">Create a WebAssign course using your
	current course in Blackboard.</bbUI:caret>

	<bbUI:caret title="Link Course" href="<%=linkHref%>">Link your course to an existing WebAssign course.</bbUI:caret>

	<bbUI:caret title="Sync Roster" href="<%=syncrosterHref%>">
	Synchronize your course roster in Blackboard to your WebAssign course.
<%  if (!roles.isEmpty()) { %>
	<br>Include other roles:
<%    for (int i = 0; i < allowedRoles.length; i++) { %>
<%      if (roles.containsKey(allowedRoles[i])) { %>
	<input type="checkbox" name="include_<%=roleCheckboxes[i]%>" value="true"><%=roleDisplay[i]%>
<%      } %>
<%    } %>
<%  } %>
	</bbUI:caret>

</bbUI:caretList>

</form>

<%   } %>
<% } else { %>
<p>WebAssign is currently unavailable or inaccessible. Please try again later.</p>
<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
