<%@page import="java.io.*,
                blackboard.data.*,
                blackboard.data.user.*,
                blackboard.data.course.*,
                blackboard.persist.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	boolean fault = false;
	boolean cerror = false;
	boolean access = false;

	if ((institutionCode.length() > 0) && (institutionKey.length() > 0)) {
		if (com.webassign.Conn.webassignIsUp()) {
			// get course properties
			Course bbcourse = ctx.getCourse();
			BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
			FileSystemService fileSysService = (FileSystemService)
				BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
			File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
			File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

			com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
			String wacourseID = wacourseprops.getProp("course.id");
			if (wacourseID.length() > 0) {
				User bbuser = ctx.getUser();
				com.webassign.SOAP wacourseSOAP = new com.webassign.SOAP("courseOptionsLink");
				wacourseSOAP.addElem("username",bbuser.getUserName());
				wacourseSOAP.addElem("institution",institutionCode);
				wacourseSOAP.addElem("courseID",wacourseID);
				wacourseSOAP.sendCall(institutionKey);

				if (wacourseSOAP.droppedCall()) {
					fault = true;
				}
				else if (wacourseSOAP.getResultByKey("result").equals("link")) {
					String courseOptionsLink = wacourseSOAP.getResultByKey("courseOptionsLink");
					String courseOptionsURL = com.webassign.Conn.getFacultyURL() + "?" + courseOptionsLink;
					response.sendRedirect(response.encodeRedirectURL(courseOptionsURL));
				}
				else if (wacourseSOAP.getResultByKey("result").equals("accessDenied")) {
					access = true;
				}
				else {
					cerror = true;
				}
			}
		}
	}

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="WebAssign">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> More Options</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:titleBar iconUrl="/images/ci/icons/bookopen_u.gif">More Options</bbUI:titleBar>

<% if (fault || cerror) { %>

<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>

<% } else if (access) { %>

<bbUI:receipt type="FAIL">
You do not appear to have access to this course. Please contact <a href="mailto:support@webassign.net">WebAssign</a> for help.
</bbUI:receipt>

<% } else { %>

<bbUI:receipt type="FAIL">
WebAssign is currently unavailable or inaccessible. Please try again later.
</bbUI:receipt>

<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
