<%@page import="java.io.*,
                java.util.*,
                blackboard.base.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.course.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );
	Course bbcourse = ctx.getCourse();
	BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();

	CourseMembershipDbLoader cmLoader = (CourseMembershipDbLoader) bbPm.getLoader( CourseMembershipDbLoader.TYPE );

	UserDbLoader uLoader = (UserDbLoader) bbPm.getLoader( UserDbLoader.TYPE );
	BbList userList = uLoader.loadByCourseId(bbcourse.getId());
	ListIterator userIterator = userList.listIterator();

	Hashtable roles = new Hashtable();
	CourseMembership.Role[] allowedRoles = {
		CourseMembership.Role.INSTRUCTOR,
		CourseMembership.Role.TEACHING_ASSISTANT,
		CourseMembership.Role.GRADER,
		CourseMembership.Role.COURSE_BUILDER
	};
	String[] roleCheckboxes = {
		"instructor",
		"teaching_assistant",
		"grader",
		"course_builder"
	};
	for (int i = 0; i < allowedRoles.length; i++) {
		roles.put(allowedRoles[i],roleCheckboxes[i]);
	}

	boolean haveStudents = false;
	int bbstudentCount = 0;
	List bbstudents = new ArrayList();
	while (userIterator.hasNext()) {
		User u = (User) userIterator.next();
		try {
			CourseMembership cm = cmLoader.loadByCourseAndUserId(bbcourse.getId(),u.getId());
			if (cm.getRole() == CourseMembership.Role.STUDENT) {
				bbstudents.add(bbstudentCount,u);
				bbstudentCount++;
				haveStudents = true;
			}
			else if (roles.containsKey(cm.getRole())) {
				String roleParam = "include_" + roles.get(cm.getRole()).toString();
				if ((request.getParameter(roleParam) != null) && (request.getParameter(roleParam).equals("true"))) {
					bbstudents.add(bbstudentCount,u);
					bbstudentCount++;
					haveStudents = true;
				}
			}
		} catch (Exception e) {
		}
	}

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String createHref = "create.jsp?course_id=" + ctx.getCourseId().toExternalString();
	String linkHref = "link.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="Sync Roster">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Sync Roster</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:titleBar iconUrl="/images/ci/icons/bookopen_u.gif">Sync Roster</bbUI:titleBar>

<% if (haveStudents) { %>

<%
	FileSystemService fileSysService = (FileSystemService)
		BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
	File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
	File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

	boolean linkedCourse = false;
	com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
	String wacourseID = wacourseprops.getProp("course.id");
	if (wacourseID.length() > 0) linkedCourse = true;

	List wacreateList = new ArrayList();
	List waupdateList = new ArrayList();
	List wadropList = new ArrayList();
	List wanochangeList = new ArrayList();

	boolean fault = false;
	boolean cerror = false;

	if (linkedCourse) {
		File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
		File configFile = new File(configDir,com.webassign.Props.propFileName());
		com.webassign.Props waprops = new com.webassign.Props(configFile);
		String institutionCode = waprops.getProp("institution.code");
		String institutionKey = waprops.getProp("institution.key");

		com.webassign.SOAP warosterSOAP = new com.webassign.SOAP("compareRoster");
		warosterSOAP.addElem("courseID",wacourseID);
		warosterSOAP.addElem("institution",institutionCode);

		for (int i = 0; i < bbstudents.size(); i++) {
			User u = (User) bbstudents.get(i);
			warosterSOAP.addElem("username",u.getUserName());
			warosterSOAP.addElem("fullname",u.getFamilyName() + ", " + u.getGivenName() + " " + u.getMiddleName());
			warosterSOAP.addElem("email",u.getEmailAddress());
			warosterSOAP.addElem("index",Integer.toString(i));
		}

		warosterSOAP.sendCall(institutionKey);

		if (warosterSOAP.droppedCall()) {
			fault = true;
		}
		else if (warosterSOAP.getResultByKey("result").equals("success")) {
			String c = warosterSOAP.getResultByKey("count");
			int count = Integer.parseInt(c);
			for (int i = 0; i < count; i++) {
				String index = warosterSOAP.getResultByKey("index" + i);
				int bbindex = Integer.parseInt(index);

				String status = warosterSOAP.getResultByKey("stat" + i);

				if (status.equals("new") || status.equals("add")) {
					int wacreateIndex = wacreateList.size();
					wacreateList.add(wacreateIndex,bbstudents.get(bbindex));
				}
				else if (status.equals("update")) {
					int waupdateIndex = waupdateList.size();
					waupdateList.add(waupdateIndex,bbstudents.get(bbindex));
				}
				else if (status.equals("none")) {
					int wanochangeIndex = wanochangeList.size();
					wanochangeList.add(wanochangeIndex,bbstudents.get(bbindex));
				}
			}

			// drop students on wa list but not on bb list
			String d = warosterSOAP.getResultByKey("dcount");
			int dcount = Integer.parseInt(d);
			for (int j = 0; j < dcount; j++) {
				Hashtable htable = new Hashtable();
				htable.put("userName",warosterSOAP.getResultByKey("drop" + j + "username"));
				htable.put("userFullname",warosterSOAP.getResultByKey("drop" + j + "fullname"));
				htable.put("userEmail",warosterSOAP.getResultByKey("drop" + j + "email"));
				wadropList.add(j,htable);
			}
		}
		else {
			cerror = true;
		}
	}

%>

<%   if (linkedCourse) { %>
<%     if (fault || cerror) { %>
<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>
<%     } else { %>

<form method="post" action="dosync.jsp">
<input type="hidden" name="course_id" value="<%=ctx.getCourseId().toExternalString()%>">
<%
	for (int i = 0; i < allowedRoles.length; i++) {
		String roleParam = "include_" + roleCheckboxes[i];
		if ((request.getParameter(roleParam) != null) && (request.getParameter(roleParam).equals("true"))) {
%>
<input type="hidden" name="<%=roleParam%>" value="true">
<%      } %>
<%  } %>

<%       if (wacreateList.size() > 0) { %>

<p><b>Additions</b><br>The following users will be added to the roster for your WebAssign course.</p>

<bbUI:list collection="<%=wacreateList%>" objectId="u" className="User" description="List of users to add." resultsPerPage="-1">
<bbUI:listElement label="Name" abbr="Name">
<%=u.getFamilyName()%>, <%=u.getGivenName()%>
</bbUI:listElement>
<bbUI:listElement label="User Name" abbr="User Name">
<%=u.getUserName()%>
</bbUI:listElement>
<bbUI:listElement label="Email" abbr="Email">
<%=u.getEmailAddress()%>
</bbUI:listElement>
</bbUI:list>

<%       } %>
<%       if (waupdateList.size() > 0) { %>

<p><b>Updates</b><br>Information for the following users will be updated to agree with
the information in your Blackboard course.</p>

<bbUI:list collection="<%=waupdateList%>" objectId="u" className="User" description="List of users to update." resultsPerPage="-1">
<bbUI:listElement label="Name" abbr="Name">
<%=u.getFamilyName()%>, <%=u.getGivenName()%>
</bbUI:listElement>
<bbUI:listElement label="User Name" abbr="User Name">
<%=u.getUserName()%>
</bbUI:listElement>
<bbUI:listElement label="Email" abbr="Email">
<%=u.getEmailAddress()%>
</bbUI:listElement>
</bbUI:list>

<%       } %>
<%       if (wadropList.size() > 0) { %>

<p><b>Extra users in the WebAssign roster</b><br>
The following users were found on your WebAssign roster, but were not found on your Blackboard roster.<br>

<bbUI:dataElement label="">
<input type="checkbox" name="wadrop" value="yes" checked>
</bbUI:dataElement>

Drop these students from my WebAssign roster.</p>

<bbUI:list collection="<%=wadropList%>" objectId="ht" className="Hashtable" description="List of users to drop." resultsPerPage="-1">
<bbUI:listElement label="Name" abbr="Name">
<%=ht.get("userFullname").toString()%>
</bbUI:listElement>
<bbUI:listElement label="User Name" abbr="User Name">
<%=ht.get("userName").toString()%>
</bbUI:listElement>
<bbUI:listElement label="Email" abbr="Email">
<%=ht.get("userEmail").toString()%>
</bbUI:listElement>
</bbUI:list>

<%       } %>
<%       if (wanochangeList.size() > 0) { %>

<p><b>No Change</b><br>The following users were found on both rosters with identifical information.
No change will occur.</p>

<bbUI:list collection="<%=wanochangeList%>" objectId="u" className="User" description="List of users with no change." resultsPerPage="-1">
<bbUI:listElement label="Name" abbr="Name">
<%=u.getFamilyName()%>, <%=u.getGivenName()%>
</bbUI:listElement>
<bbUI:listElement label="User Name" abbr="User Name">
<%=u.getUserName()%>
</bbUI:listElement>
<bbUI:listElement label="Email" abbr="Email">
<%=u.getEmailAddress()%>
</bbUI:listElement>
</bbUI:list>
<%       } %>

<div align="right">
<bbUI:button type="FORM_ACTION" name="cancel" alt="Cancel" action="LINK" targetUrl="javascript:history.go(-1)" />
<bbUI:button type="FORM_ACTION" name="submit" alt="Sync Roster" action="SUBMIT_FORM" />
</div>

</form>

<%     } %>
<%   } else { %>

<p>Your Blackboard course is not linked to a WebAssign course. Click one of the options below.</p>

<bbUI:caretList>
	<bbUI:caret title="Create WebAssign Course" href="<%=createHref%>">Create a WebAssign course using your
	current course in Blackboard.</bbUI:caret>

	<bbUI:caret title="Link Course" href="<%=linkHref%>">Link your course to an existing WebAssign course.</bbUI:caret>
</bbUI:caretList>

<div align="right">
<bbUI:button type="FORM_ACTION" name="ok" alt="OK" action="LINK" targetUrl="javascript:history.go(-1)" />
</div>

<%   } %>

<% } else { %>

<p>No users with Student Role were found.</p>

<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
