<%@page import="java.io.*,
                blackboard.data.*,
                blackboard.data.course.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.platform.*,
                blackboard.platform.filesystem.*,
                blackboard.platform.plugin.*,
                blackboard.platform.session.*,
                com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<%
	BbSession bbSession = BbServiceManager.getSessionManagerService().getSession( request );

	boolean linkedCourse = false;
	Course bbcourse = ctx.getCourse();
	BbPersistenceManager bbPm = BbServiceManager.getPersistenceService().getDbPersistenceManager();
	FileSystemService fileSysService = (FileSystemService)
		BbServiceManager.lookupService(blackboard.platform.filesystem.FileSystemService.class);
	File courseContentDir = fileSysService.getCourseDirectory(bbcourse);
	File courseConfigFile = new File(courseContentDir,com.webassign.Props.propFileName());

	com.webassign.Props wacourseprops = new com.webassign.Props(courseConfigFile);
	String wacourseID = wacourseprops.getProp("course.id");
	if (wacourseID.length() > 0) linkedCourse = true;

	String mainHref = "main.jsp?course_id=" + ctx.getCourseId().toExternalString();
%>

<bbUI:docTemplate title="Unlink Course">
<bbUI:coursePage courseId="<%=bbSession.lookupCourseContext(request).getCourseId()%>">

<bbUI:breadcrumbBar handle="control_panel">
	<bbUI:breadcrumb href="<%=mainHref%>"> WebAssign</bbUI:breadcrumb>
	<bbUI:breadcrumb> Unlink Course</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<% if (linkedCourse) { %>

<%
	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	boolean unlinkedCourse = false;
	boolean fault = false;
	boolean cerror = false;

	if (com.webassign.Conn.webassignIsUp()) {
		com.webassign.SOAP waSOAP = new com.webassign.SOAP("unlinkCourse");
		waSOAP.addElem("institution",institutionCode);
		waSOAP.addElem("course",wacourseID);
		waSOAP.sendCall(institutionKey);

		if (waSOAP.droppedCall()) {
			fault = true;
		}
		else if (waSOAP.getResultByKey("result").equals("success")) {
			wacourseprops.setProp("course.id","");
			wacourseprops.saveProps();
			unlinkedCourse = true;
		}
		else {
			cerror = true;
		}
	}
%>

<% if (fault || cerror) { %>
<bbUI:receipt type="FAIL">
There was an error processing this request. Please try again later.
</bbUI:receipt>
<% } else if (unlinkedCourse) { %>
<bbUI:receipt type="SUCCESS" recallUrl="<%=mainHref%>">
Your Blackboard course is no longer linked to your WebAssign course.
</bbUI:receipt>
<% } else { %>
<bbUI:receipt type="FAIL" recallUrl="<%=mainHref%>">
Your course could not be unlinked.
</bbUI:receipt>
<% } %>

<% } else { %>

<p>Your course is not linked to an WebAssign course.</p>

<% } %>

</bbUI:coursePage>
</bbUI:docTemplate>

</bbData:context>
