<%@page import="java.util.*,
                java.io.*,
                java.net.*,
                blackboard.data.user.*,
                blackboard.platform.plugin.*,
				com.webassign.*"
        errorPage="/error.jsp"
%>

<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">

<%

    User user = ctx.getUser();

	File configDir = PlugInUtil.getConfigDirectory(com.webassign.Props.vid(),com.webassign.Props.handle());
	File configFile = new File(configDir,com.webassign.Props.propFileName());
	com.webassign.Props waprops = new com.webassign.Props(configFile);
	String institutionCode = waprops.getProp("institution.code");
	String institutionKey = waprops.getProp("institution.key");

	String result = null;

	if ((institutionCode.length() > 0) && (institutionKey.length() > 0)) {
		if (com.webassign.Conn.webassignIsUp()) {
			com.webassign.SOAP waSOAP = new com.webassign.SOAP("login");
			waSOAP.addElem("username",user.getUserName());
			waSOAP.addElem("institution",institutionCode);
			waSOAP.sendCall(institutionKey);

			if (!waSOAP.droppedCall()) {
				result = waSOAP.getResultByKey("result");
				if (result.equals("valid")) {
					String bbrel6 = waSOAP.getResultByKey("bbrel6");
					String webassignLogin = com.webassign.Conn.getLoginURL() + "?bbrel6=" + bbrel6;
					response.sendRedirect(response.encodeRedirectURL(webassignLogin));
				}
			}
        }
		else {
			result = "connection";
		}
    }
	else {
		result = "settings";
	}
%>

<bbUI:docTemplate>

<bbUI:breadcrumbBar environment="course">
	<bbUI:breadcrumb> WebAssign</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<p>
<% if (result.equals("settings")) { %>

The WebAssign Institution Code has not been set. Please contact your teacher or system administrator.

<% } else if (result.equals("connection")) { %>

WebAssign is currently unavailable or inaccessible. Please try again later.

<% } else if (result.equals("unknownUser")) { %>

Your account was not found in WebAssign. Please contact your teacher.

<% } else { %>

An error occurred. Please contact your teacher. If this error persists
please contact <a href="mailto:support@webassign.net">WebAssign</a>.

<% } %>
</p>

</bbUI:docTemplate>

</bbData:context>
